const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "F";

const tools = require('../tools/general');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const StatusSkillSchema = new Schema({
  _id: {
    type: Number,
  },
  descr: {
    type: String,
  },
  color: {
    type: String,
  },
  icon: {
    type: String,
  },
  theme: {
    type: String,
  },
});

StatusSkillSchema.pre('save', async function (next) {
  if (this.isNew) {
    const myrec = await StatusSkill.findOne().limit(1).sort({_id:-1});
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;

    } else {
      this._id = 1;
    }
  }

  next();
});



StatusSkillSchema.statics.findAllIdApp = async function (idapp) {
  const StatusSkill = this;

  const query = [
    { $sort: { descr: 1 } }
  ];

  return await StatusSkill
    .aggregate(query)
    .then((arrrec) => {
      return arrrec
    })

};

StatusSkillSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'descr', type: tools.FieldType.string }]
};

StatusSkillSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};


const StatusSkill = mongoose.model('StatusSkill', StatusSkillSchema);

StatusSkill.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });


module.exports = { StatusSkill };
